



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spark集群 + Akka + Kafka + Scala 开发(2) : 开发一个Spark应用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spark集群 + Akka + Kafka + Scala 开发(2) : 开发一个Spark应用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:15:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>[comment]: # Spark集群 + Akka + Kafka + Scala 开发(2) : 开发一个Spark应用</p>
<h1>前言</h1>
<p>在<a href="http://www.cnblogs.com/steven-yang/p/5926335.html" rel="external nofollow noreferrer">Spark集群 + Akka + Kafka + Scala 开发(1) : 配置开发环境</a>，我们已经部署好了一个Spark的开发环境。<br /><br />
本文的目标是写一个Spark应用，并可以在集群中测试。</p>
<h1>创建一个Scala的工程- SimpleAPP</h1>
<ul><li>建一个目录SimpleAPP</li></ul>
<pre class="prettyprint linenums"><code>mkdir SimpleAPP<br />
mkdir -p SimpleAPP/src/main/scala<br />
</code></pre>
<ul><li>建一个SimpleAPP/src/main/scala/SimpleApp.scala文件<br /><br />
这个程序会进行MapReduce计算，计算从1到输入参数n的平方和。</li></ul>
<pre class="prettyprint linenums"><code>import org.apache.spark.SparkContext<br />
import org.apache.spark.SparkContext._<br />
import org.apache.spark.SparkConf

object SimpleApp {<br />
  def main(args: Array[String]) {<br />
    squareSum(10000)<br />
  }

  private def squareSum(n: Long): Long = {<br />
    val conf = new SparkConf().setAppName(&quot;Simple Application&quot;)<br />
    val sc = new SparkContext(conf)

    val squareSum = sc.parallelize(1L until n).map { i =&gt;<br />
      i * i<br />
    }.reduce(_ + _)

    println(s&quot;============== The square sum of $n is $squareSum. ==============&quot;)

    squareSum<br />
  }<br />
}<br />
</code></pre>
<ul><li>建一个SimpleAPP/build.sbt文件</li></ul>
<pre class="prettyprint linenums"><code>name := &quot;Simple Application Project&quot;

version := &quot;1.0&quot;

scalaVersion := &quot;2.11.8&quot;

libraryDependencies += &quot;org.apache.spark&quot; %% &quot;spark-core&quot; % &quot;2.0.0&quot;<br />
</code></pre>
<h1>构建你的工程</h1>
<ul><li>构建工程</li></ul>
<pre class="prettyprint linenums"><code># move to the project folder<br />
cd SimpleAPP

# build the project<br />
sbt package<br />
</code></pre>
<p>Output:</p>
<blockquote><p>[info] Packaging .../<strong>target/scala-2.11/simple-application-project_2.11-1.0.jar</strong> ...<br /><br />
[info] Done packaging.</p></blockquote>
<p>粗体的部分是构建出来的jar文件相对路径。需要记住，运行的时候有用。</p>
<ul><li>运行工程<br /><br />
使用spark提供的命令运行我们的spark应用。<br /><br />
<code>--master local[4]</code>表示在local模式下运行，使用4个线程。</li></ul>
<pre class="prettyprint linenums"><code># run the project in local with 4 threads<br />
$SPARK_HOME/bin/spark-submit --master local[4] --class SimpleApp target/scala-2.11/simple-application-project_2.11-1.0.jar<br />
</code></pre>
<p>输出 （会有很多的log输出）:</p>
<blockquote><p>...<br /><br />
============== The square sum of 10000 is 333283335000. ==============<br /><br />
...</p></blockquote>
<p><strong>现在，我们完成了一个简单的spark工程的开发。下一步，看看如何在集群中运行。</strong></p>
<h1>启动一个standalone集群环境。</h1>
<p>部署一个standalone集群环境不是本文要讲的内容。<br /><br />
所以，现在我们只使用单机上的集群功能。<br /><br />
如果想部署一个有多个机器的standalone集群环境，可以查看在官网上的说明。部署起来也比较简单。</p>
<h2>基本概念</h2>
<ul><li><p>Master server<br /><br />
集群环境中，主从架构里的主服务器。<br /><br />
可以有多个master server，只能有一个是leader，其它的都是standby。（我猜的）<br /><br />
Spark使用ZooKeeper的实现主服务器的灾难恢复。</p></li>
<li><p>Slave worker<br /><br />
集群环境中，主从架构里的从服务器。</p></li>
<li><p>Master URL<br /><br />
在standalone集群环境中，master服务器启动后，master服务器提供了一个master URL用于和slave workers交互。<br /><br />
默认的Master URL是：<code>spark://$(hostname):7077</code><br /><br />
实际的Master URL可以在master服务器的日志中找到。<br /><br />
这个Master URL用于:</p>
<ul><li>启动slave workers。</li>
<li>Spark应用的<code>--master</code>配置。</li></ul></li>
<li><p>Master Web UI<br /><br />
在master服务器启动后，master服务器提供了一个web应用，可以通过浏览器来查看运行的状态。<br /><br />
默认的Master Web UI URL是：<code>http://localhost:8080</code><br /><br />
实际的Master Web UI URL可以在master服务器的日志中找到。</p></li>
<li><p>Slave Web UI<br /><br />
在Slave worker启动后，slave worker提供了一个web应用，可以通过浏览器来查看运行的状态。<br /><br />
默认的Slave Web UI URL是：<code>http://localhost:8081</code><br /><br />
实际的Slave Web UI URL可以在master服务器的日志中找到。</p></li></ul>
<h2>启动master和slave服务</h2>
<ul><li>启动master服务器</li></ul>
<pre class="prettyprint linenums"><code># start master<br />
$SPARK_HOME/sbin/start-master.sh<br />
</code></pre>
<p>输出:</p>
<blockquote><p>starting org.apache.spark.deploy.master.Master, logging to <strong>/opt/spark/logs/spark-steven-org.apache.spark.deploy.master.Master-1-sycentos.localdomain.out</strong></p></blockquote>
<ul><li>如果需要，查看一个Master URL</li></ul>
<pre class="prettyprint linenums"><code># We need get the spark master url<br />
cat $SPARK_HOME/logs/spark-steven-org.apache.spark.deploy.master.Master-1-sycentos.localdomain.out | grep Master:<br />
# or<br />
cat $SPARK_HOME/logs/spark-$(whoami)-org.apache.spark.deploy.master.Master-1-$(hostname).out | grep Master:<br />
</code></pre>
<p>输出：</p>
<blockquote><p>16/09/23 19:45:37 INFO Master: Started daemon with process name: 4604@sycentos.localdomain<br /><br />
16/09/23 19:45:42 INFO Master: Starting Spark master at <strong>spark://sycentos.localdomain:7077</strong><br /><br />
16/09/23 19:45:42 INFO Master: Running Spark version 2.0.0<br /><br />
16/09/23 19:45:44 INFO Master: I have been elected leader! New state: ALIVE<br /><br />
16/09/23 19:59:26 INFO Master: Registering worker 10.0.2.15:36442 with 4 cores, 2.7 GB RAM<br /><br />
16/09/23 20:15:13 INFO Master: 10.0.2.15:42662 got disassociated, removing it.<br /><br />
16/09/23 20:15:13 INFO Master: 10.0.2.15:36442 got disassociated, removing it.<br /><br />
16/09/23 20:15:13 INFO Master: Removing worker worker-20160923195923-10.0.2.15-36442 on 10.0.2.15:36442<br /><br />
16/09/23 20:15:39 INFO Master: Registering worker 10.0.2.15:42462 with 4 cores, 2.7 GB RAM</p>
<p>Note: Master: I have been elected leader! New state: ALIVE<br /><br />
粗体就是Master URL.</p></blockquote>
<ul><li>启动slave</li></ul>
<pre class="prettyprint linenums"><code>$SPARK_HOME/sbin/start-slave.sh spark://$(hostname):7077<br />
# or<br />
# $SPARK_HOME/sbin/start-slave.sh spark://sycentos.localdomain:7077<br />
</code></pre>
<p>输出：</p>
<blockquote><p>starting org.apache.spark.deploy.worker.Worker, logging to /opt/spark/logs/spark-steven-org.apache.spark.deploy.worker.Worker-1-sycentos.localdomain.out</p></blockquote>
<ul><li>如果需要，检测是否slave被成功启动了。</li></ul>
<pre class="prettyprint linenums"><code>cat $SPARK_HOME/logs/spark-$(whoami)-org.apache.spark.deploy.worker.Worker-1-$(hostname).out | grep spark://<br />
# or<br />
# cat $SPARK_HOME/logs/spark-steven-org.apache.spark.deploy.worker.Worker-1-sycentos.localdomain.out<br />
</code></pre>
<p>输出：</p>
<blockquote><p>16/09/23 20:15:39 INFO Worker: Successfully registered with master spark://sycentos.localdomain:7077</p></blockquote>
<p><strong>这时，spart的master和slave服务都已经启动。</strong></p>
<p>说明一下，关闭Master的命令是：</p>
<pre class="prettyprint linenums"><code>$SPARK_HOME/sbin/stop-master.sh<br />
$SPARK_HOME/sbin/stop-slave.sh<br />
</code></pre>
<h1>在集群环境上，运行SimpleAPP</h1>
<p>进入到SimpleApp的目录，并运行：</p>
<pre class="prettyprint linenums"><code># run the project<br />
$SPARK_HOME/bin/spark-submit --master spark://$(hostname):7077 --class SimpleApp target/scala-2.11/simple-application-project_2.11-1.0.jar<br />
</code></pre>
<p>输出：</p>
<blockquote><p>...<br /><br />
16/09/23 20:34:40 INFO StandaloneAppClient\(ClientEndpoint: Connecting to master spark://sycentos.localdomain:7077...<br />
...<br />
16/09/23 20:34:40 INFO StandaloneAppClient\)ClientEndpoint: Executor added: app-20160923203440-0000/0 on worker-20160923201537-10.0.2.15-42462 (10.0.2.15:42462) with 4 cores<br /><br />
...</p></blockquote>
<p><strong>通过查找关键字master和worker，可以确认是在集群上运行。</strong></p>
<h1>访问master web UI.</h1>
<h2>获取Master Web UI的地址。</h2>
<p>从master服务的log里，可以找到master URL。</p>
<pre class="prettyprint linenums"><code># Query master web UI url from master service log.<br />
cat /opt/spark/logs/spark-steven-org.apache.spark.deploy.master.Master-1-sycentos.localdomain.out | grep MasterWebUI<br />
</code></pre>
<p>输出：</p>
<blockquote><p>16/09/23 19:45:43 INFO MasterWebUI: Bound MasterWebUI to 0.0.0.0, and started at <a href="http://10.0.2.15:8080" rel="external nofollow noreferrer">http://10.0.2.15:8080</a></p></blockquote>
<h2>访问Master Web UI</h2>
<p>通过浏览器访问http://localhost:8080/，可以看到有一个完成的应用。</p>
<blockquote><p>现在，我们已经可以在集群环境中运行SimpleApp</p></blockquote>
<h1>理解Spark Application</h1>
<ul><li>一个Spark Application是一个运行在<strong>Spark环境</strong>中的Java应用。</li>
<li>需要在安装了Spark的机器上，通过Spark命令来启动。</li>
<li>Spark Application是通过Spark Master URL和Spark Master Server交互，因此，不一定需要在Spark的Master或者Slave上启动。</li>
<li>Spark Application是通过SparkConf和SparkContext与Spark系统交互。</li></ul>
<h1>下面请看</h1>
<p>至此，我们已经写好了一个spark集群scala的应用。下一步请看：<br /><br />
<a href="http://www.cnblogs.com/steven-yang/p/5926726.html" rel="external nofollow noreferrer">Spark集群 + Akka + Kafka + Scala 开发(3) : 开发一个Akka + Spark的应用</a><br /><br />
<a href="http://www.cnblogs.com/steven-yang/p/5926728.html" rel="external nofollow noreferrer">Spark集群 + Akka + Kafka + Scala 开发(4) : 开发一个Kafka + Spark的应用</a></p>
<h1>参照</h1>
<ul><li><a href="http://doc.akka.io/docs/akka/2.4/scala.html" rel="external nofollow noreferrer">akka document</a></li>
<li><a href="https://en.wikipedia.org/wiki/Elasticity_%28cloud_computing%29" rel="external nofollow noreferrer">Elasticity (cloud computing)</a></li>
<li><a href="https://en.wikipedia.org/wiki/Resilient_control_systems" rel="external nofollow noreferrer">Resilient control systems</a></li>
<li><a href="https://github.com/akka/akka/tree/v2.4.10/akka-docs/rst/scala/code/docs" rel="external nofollow noreferrer">akka 2.4.10 code samples</a></li>
<li><a href="https://github.com/akka/akka/tree/master/akka-samples" rel="external nofollow noreferrer">akka office samples</a></li>
<li><a href="http://alvinalexander.com/scala/simple-akka-actors-remote-example" rel="external nofollow noreferrer">A simple Akka (actors) remote example</a></li>
<li><a href="http://letitcrash.com/post/30165507578/shutdown-patterns-in-akka-2" rel="external nofollow noreferrer">Shutdown Patterns in AKKA 2</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2vjpx8.html">zabbix3&period;0安装教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96neo4q.html">&lbrack;已解决&rsqb; java&period;net&period;ConnectException&colon; Connection refused&colon; no further information</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4v1yeq.html">启动运行下载gradle速度太慢，手动添加</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jko448.html">C&period; Graph and String</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00km0q.html">&lbrack;CSS&rsqb;三层嵌套的滑动门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mne046q.html">&lbrack;hdu 4416&rsqb;Good Article Good sentence</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gpdk8.html">Js 获取当前时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m3g71q.html">UITableView添加静态背景&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v50p38.html">R cannot be resolved to a variable</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m2mdn8.html">python3&period;4 data type</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvn268.html">【NOI2019模拟】搬砖</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojkne8.html">解决input框黄色背景问题（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1go0g9.html">StringBuilder String  string&period;Concat  字符串拼接速度再议</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4py510q.html">linux 环境变量设置方法总结（PATH &sol; LD&lowbar;LIBRARY&lowbar;PATH）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4lgvpq.html">由 Session 和 Cookie 的区别说起</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vdyl0q.html">C&num; list&period;ForEach用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kozv0jq.html">centos上yum安装nodeJS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpwdke9.html">MySql 时间处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve400y9.html">C&num; VS&comma;连接到oracle 报要升级到8&period;多少版本的错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvde0nzq.html">Spring 整合Mybatis Mapper动态代理方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r9335mr9.html">Atitit 发帖机实现&lpar;4 &rpar;- usbQBM1601 gui操作标准化规范与解决方案attilax总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8eremeq.html">Android Activity 常用技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mrn409.html">Spring&period;NET的AOP怎么玩</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy01728.html">WPF自定义控件与样式&lpar;4&rpar;-CheckBox&sol;RadioButton自定义样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jdmdg9.html">Java多线程系列--&OpenCurlyDoubleQuote;JUC集合&rdquo;02之 CopyOnWriteArrayList</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mrjzr9.html">MySQL的学习--触发器</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mrj769.html">php基础教程-变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gr3klq.html">Oracle ASM diskgroup在主机重启后启动失败</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jdn449.html">webpack打包压缩工具的使用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zer038.html">一句话讲清楚什么是JavaEE</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
